﻿(function ($, ns) {
    var deleteDialog = function (config) {
        this.init(config);
        return this;
    };

    //static method to open the vault dialog
    deleteDialog.OpenDialog = function (mediaItemId) {
        var loading = new IVNotification('Loading...', { showOverlay: true });

        app.load({
            url: 'Library/ShowDeleteDialog',
            data: { mediaItemId: mediaItemId },
            success: function (data) {
                loading.remove();
                $('body').append(data);
                $('#delete-dialog').center(false);
            },
            error: function (error) {
                loading.remove();
                app.showError("Error opening delete dialog", error);
            }
        });
    };

    deleteDialog.prototype = {
        mediaItemId: null,
        init: function (config) {
            $.extend(this, config);
            var self = this;

            $('#delete-dialog #actions .delete').click(function () {
                self.deleteFile();
                return false;
            });

            $('#delete-dialog #actions .cancel').click(function () {
                self.closeDialog();
                return false;
            });
        },
        closeDialog: function () {
            $('.dialog').remove();
            $('.overlay').fadeOut('fast', function () {
                $(this).remove();
            });
        },
        deleteFile: function () {
            var self = this;
            app.load({
                url: 'Library/Delete',
                data: { mediaItemId: self.mediaItemId },
                success: function (data) {
                    $.bbq.removeState('item');
                    self.closeDialog();
                    $('#stream li[data-item-id=' + self.mediaItemId + ']').remove();
                    app.trigger("deleteDialog:fileDeleted");
                }
            });
        }
    };
    ns.DeleteDialog = deleteDialog;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});


