﻿(function ($, ns) {

	var adminView = function (config) {
		this.init(config);
		return this;
	};

	adminView.OpenDialog = function () {
		//TODO:We need a better way of doing this...
	    var loading = new IVNotification('Loading...', { showOverlay: true });

		app.load({
			url: 'Admin',
			//type: 'GET',
			success: function (data) {
				loading.remove();
				$('body').append(data);
			},
			error: function (error) {
			    loading.remove();
			    app.showError("Error opening admin dialog", error);
			}
		});
	};

	adminView.prototype = {
		init: function (config) {
			$.extend(this, config);
			var self = this;
			//locate components
			this.dialogElement = $('#iv-admin');
			// attach event for editing metadata definitions

			$('#iv-admin #edit-meta-def').click(function () {
				if (!$(this).parent().hasClass("disabled"))
					self.selectTab('meta-def');
				return false;
			});
			// attach event for editing conversion formats
			$('#iv-admin #edit-conversions').click(function () {
				if (!$(this).parent().hasClass("disabled"))
					self.selectTab('conversions');
				return false;
			});
			// attach event for editing global categories
			$('#iv-admin #edit-categories').click(function () {
				if (!$(this).parent().hasClass("disabled"))
					self.selectTab('categories');
				return false;
			});
			// attach event for editing global categories
			$('#iv-admin #edit-global-rights').click(function () {
				if (!$(this).parent().hasClass("disabled"))
					self.selectTab('rights');
				return false;
			});
			// attach event for closing the dialog
			$('#iv-admin .close').click(function () {
				$('#iv-admin').die();
				$('.overlay').fadeOut('fast', function () {
					$(this).remove();
				});
				return false;
			});
		},
		setSelectedTab: function (id) {
			$('.dialog ul.tabs li').removeClass('selected');
			$('#' + id).parent('li').addClass('selected');
		},

		trySelectTab: function (item) {
			var $li = $('#' + item.id).parent('li');
			if ($li.hasClass("disabled")) {
				return false;
			}
			$('.dialog ul.tabs li').removeClass('selected');
			$li.addClass('selected');
			item.open();
			return true;
		},
		selectTab: function (state) {
			var items = [
				{ state: 'meta-def', id: 'edit-meta-def', open: ImageVaultUi.MetadataDefinitionView.OpenDialog },
				{ state: 'conversions', id: 'edit-conversions', open: ImageVaultUi.MediaFormatView.OpenDialog },
				{ state: 'categories', id: 'edit-categories', open: ImageVaultUi.CategoriesView.OpenDialog },
				{ state: 'rights', id: 'edit-global-rights', open: ImageVaultUi.GlobalRightsView.OpenDialog }
			];
			var selectedItem = null;
			var i;
			for (i = 0; i < items.length; i++) {
				if (items[i].state == state) {
					selectedItem = items[i];
					break;
				}
			}
			//no item with that name was found
			if (selectedItem == null)
				return;
			//try to open the requested tab.
			if (this.trySelectTab(selectedItem))
				return;
			//if that fails, try to open the first available tab
			for (i = 0; i < items.length; i++) {
				this.trySelectTab(items[i]);
			}
		}
	};
	//export to namespace
	ns.AdminView = adminView;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});
