﻿(function ($, ns) {
    var thumbnailLoader = function () {
        return this;
    };

    ns.ThumbnailLoader = thumbnailLoader;
    ns.ThumbnailLoader.HandleError = function (element) {
        
        var $img = $(element);

        // remove error event on element
        // so we don't get stuck in a loop
        $img.removeAttr("onerror");
        var loadingImgSrc = app.createPath("Images/big_loader.gif");

        // replace with spinner as temporary source
        var $loadingImage = $('<img>', {
            src: loadingImgSrc,
            style: "margin: 20px;",
            alt: "Loading",
            name: "Loading",
            title: "Loading"
        });

        $img.replaceWith($loadingImage);

        // start the loop for checking images
        $.ajax({
            url: $(element).attr("src"),
            complete: function (request, status) {
                validImageChecker(request, status, $loadingImage, $img);
            }
        });

        var validImageChecker = function (request, status, currentDomImage, originalImage) {
            // if we have 503, new request after Retry-After seconds
            if (request && request.status == 503) {

                var timeout = parseInt(request.getResponseHeader("Retry-After")) || 3;

                setTimeout(function () {
                    $.ajax({
                        url: originalImage.attr("src"),
                        complete: function (request, status) {
                            validImageChecker(request, status, currentDomImage, originalImage);
                        }
                    });
                }, timeout * 1000);
            } else {
                // restore the original image
                // the source needs to be appended with dummy value to re-draw the dom
                var sourceString = originalImage.attr("src") + "?" + new Date().getTime();
                originalImage.attr("src", sourceString);
                currentDomImage.replaceWith(originalImage);
            }
        };

    };
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});