﻿(function ($, ns) {
	var nav = function (config) {
		this.init(config);
		return this;
	};
	nav.prototype = {
		navLibraryTab: null,
		navCategoriesTab: null,
		navToolbar: null,
		currentTab: null,
		init: function (config) {
			$.extend(this, config);
			var self = this;

			//Show scrollbar on area hover
			$('#nav').hover(
                function () { $('#nav .scrollbars .track').fadeIn('fast'); },
                function () { $('#nav .scrollbars .track').fadeOut('fast'); }
            );

			
			this.navToolbar = new ImageVaultUi.NavToolbar({ $domobject: $("div#nav-toolbar") });
			this.navLibraryTab = new ImageVaultUi.NavLibraryTab({ nav: this, $domobject: $("div#vaults") });
			this.navCategoriesTab = new ImageVaultUi.NavCategoriesTab({ nav: this, $domobject: $("div#categories") });
			this.loadTab("categories");

			this.initViewport();

			//Navigtation tab events
			$('#nav-tabs a').click(function () {
				//Push state to hash
				var state = {};
				state['tab'] = $(this).attr('class');
				$.bbq.pushState(state);
				return false;
			});


			$(window).bind('hashchange', function (e) {
				var tab = $.bbq.getState('tab');
				if (typeof tab === 'undefined') {
					return;
				}
				//ignore selected tabs
				if (MeridiumUtil.endsWith(tab, " selected")) {
					return;
				}
				self.loadTab(tab);
			});

			//Resize nav height on window resize 
			$(window).resize(function () {
				self.initViewport();
			});
		},
		loadTab: function (tab) {

			var self = this;
			var newTab = undefined;
			if (tab == "vaults") {
				newTab = this.navLibraryTab;
			} else if (tab == "categories") {
				newTab = this.navCategoriesTab;
			}
			//skip reloading same tab...
			if (newTab == this.currentTab)
				return;

			if (newTab === undefined) {
				throw "undefined tab " + tab;
			}
			$('#nav-tabs a').removeClass('selected');
			if (this.currentTab != undefined) {
				this.currentTab.hide();
			}
			this.currentTab = newTab;
			var $tab = $('#nav-tabs a.' + tab);
			$tab.addClass('selected');
			this.currentTab.show();

			//			$('#categories, #vaults, #filters').hide();
			//			$('#' + tab).show();

			self.initViewport();
		},
		initViewport: function () {
			//Calculate height och scrollable area
			var height = $('#nav').height() - $('#nav-tabs').height() - $('#nav-toolbar').height();
			$('#nav-viewport').height(height - 10);
			//Init scrollbar
			$('#nav-viewport').jScrollPane();
		}
	};
	//export to namespace
	ns.Nav = nav;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});
