﻿(function ($, ns, undefined) {
	var navtoolbar = function (config) {
		this.init(config);
		return this;
	};
	navtoolbar.prototype = {
		//properties
		$domobject: undefined,
		createPopupMenu: null,
		//method
		init: function (config) {
			$.extend(this, config);
			if (this.$domobject === undefined)
				throw "$domobject is not defined in config";
			this.disableAllButtons();
			var self = this;
			var popupDom = $("#create-menu", this.$domobject);
			this.createPopupMenu = new ImageVaultUi.PopupMenu({ $domobject: popupDom });
			this.createPopupMenu.hide();
			this.createPopupMenu.bind("createVaultClick", function () { ImageVaultUi.VaultDialog.OpenDialog(-1); });
			this.createPopupMenu.bind("createCategoryClick", function () {
			    $.bbq.pushState({ 'admin-tab': 'categories' });
			    ImageVaultUi.AdminView.OpenDialog();
			});

			//toggle create popup when click on the create button
			$("a[data-name='create']", this.$domobject).click(function () {
				//don't bubble disabled button events
				if ($(this).hasClass('disabled'))
					return false;
				self.createPopupMenu.toggle();
				return false;
			});
			//toggle create popup when click on all buttons that isn't create
			$(">ul a[data-name!='create']", this.$domobject).click(function () {
				//don't bubble disabled button events
				if ($(this).hasClass('disabled'))
					return false;
				var dataName = $(this).attr("data-name");
				app.trigger("navtoolbar:" + dataName + "Click");
				return false;
			});

			if (app.isUserInRole(ImageVaultUi.GlobalRoles.Administrator | ImageVaultUi.GlobalRoles.CategoryAdministrator)) {
				this.enableButton("create");
			}

			app.bind("navtoolbar:enableButton", this.enableButton, this);
			app.bind("navtoolbar:disableButton", this.disableButton, this);

		},
		getButtonContainer: function (name) {
			return this.getButton(name).parent();
		},
		getButton: function (name) {
			var button = $("a[data-name='" + name + "']", this.$domobject);
			if (button.length == 0)
				button = $("a#" + name, this.$domobject);
			return button;
		},
		//shows a button
		showButton: function (name) {
			this.getButtonContainer(name).show();
		},
		enableButton: function (name) {
			this.getButton(name).removeClass('disabled');
		},
		disableButton: function (name) {
			this.getButton(name).addClass('disabled');
		},
		disableAllButtons:function () {
			$(">ul li", this.$domobject).addClass('disabled');
		}
//		setupButtons: function (buttons) {
//			this.hideAllButtons();
//			var buttonNames = _.keys(buttons);
//			for (var i = 0; i < buttonNames.length; i++) {
//				var name = buttonNames[i];
//				var val = buttons[name];
//				if (val == "disabled") {
//					this.disableButton(name);
//				} else {
//					this.enableButton(name);
//				}
//				this.showButton(name);
//			}
//		}

	};
	ns.NavToolbar = navtoolbar;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});