﻿(function ($, ns) {
    var organizeView = function (config) {
        this.init(config);
        return this;
    };
    organizeView.prototype = {
        currentSelection: null,
        init: function (config) {
            //map external functions
            $.extend(this, config);
            var self = this;
            var organizeToolbar = new ImageVaultUi.OrganizeAllItemsToolbar({ $domobject: $("#organize-toolbar") });

            app.bind("category:edited", this.refreshCategoryList, this);
            app.bind("category:added", this.refreshCategoryList, this);
            app.bind("category:deleted", this.refreshCategoryList, this);

            var $form = $("form");
            //			// disable organize anchor
            //			$('a.organize').click(function (e) {
            //				if ($(this).hasClass('inactive')) {
            //					e.preventDefault();
            //				}
            //			});
            
            $form.submit(function () {
                $(this).find(':submit').css('opacity', '0.5');
                $(':submit', this).click(function () {
                    console.log('tab that ass');
                    return false;
                });

            });

            //iterate all category dropdowns for all items and create popup instances for them
            $('div.dropdown', $form).each(function () {
                var $dropdown = $(this);
                //anchor is the link that displays the selected categories
                var $anchor = $dropdown.prev('a.dropdown');
                //create popup
                var popup = new ImageVaultUi.OrganizeCategoryPopupMenu({ $domobject: $dropdown });
                popup.updateAnchorText($anchor);
                $anchor.click(function () {
                    popup.toggle();
                    return false;
                });
                //if popup changes the categories, update the anchor
                popup.bind("category:changed", function () {
                    popup.updateAnchorText($anchor);
                    //update the selectedCategories input field
                    var selectedCategories = popup.getSelectedCategories();
                    $("input[type='hidden']", $dropdown.parent()).val(selectedCategories.join());
                });
            });

            // remove single duplicate from the organize batch
            var $removeSingleDuplicateButton = $('.duplicatewrapper a.delete');
            $removeSingleDuplicateButton.click(function (event) {
                var $mediaId = parseInt($(event.target).attr('data-media-id'), 10);
                self.removeMediaItems([$mediaId]);
            });

            // remove all duplicates from the organize batch
            var $removeAllDuplicateButton = $('li.duplicates');
            if ($removeAllDuplicateButton) {
                $removeAllDuplicateButton.click(function(event) {
                    var $medias = $('.duplicatewrapper a.delete').map(function () {
                        return parseInt($(this).attr('data-media-id'), 10);
                    }).get();
                    self.removeMediaItems($medias);
                });
            }
        },
        // deletes and removes media items from the organize batch
        removeMediaItems: function(mediaIds) {
            app.load({
                controller: 'organize',
                action: 'removeduplicates',
                data: { mediaIds: mediaIds },
                success: function (data) {
                    window.location.replace(data.replace(/"/g, ''));
                }
            });
        },
        //refreshes the category list
        refreshCategoryList: function () {
            app.load({
                controller: 'organize',
                action: 'refreshcategorytree',
                success: function (data) {
                    app.trigger("organize:categoriesChanged", data);
                }
            });
        }


    };
    ns.OrganizeView = organizeView;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});