﻿(function ($, ns, undefined) {
	var organizeAllItemsToolbar = Backbone.Model.extend({
		//############################################
		//##  Attributes
		//############################################
		categoryDropDown: null,

		//############################################
		//##  Functions
		//############################################
		//Initializes the object. Run on creation
		initialize: function () {
			var $domobject = this.get('$domobject');
			if ($domobject === undefined)
				throw "$domobject is not defined in config";
			//if toolbar is hidden, ignore the rest
			if ($domobject.length == 0)
				return;

			//initialization code here

			//Metadata dropdown
			var $metadatas = $('.metadatas', $domobject);
			var $metadataButton = $("a", $metadatas);
			if (!$metadataButton.hasClass("inactive")) {
				var $mddrop = $metadatas.find('.dropdown');
				var metadataDropDown = new ImageVaultUi.PopupMenu({ $domobject: $mddrop });
				$metadataButton.click(function () {
					metadataDropDown.toggle();
					return false;
				});
				//connect events for the metadata dropdown
				$metadatas.find('input[type=checkbox]').change(function () {
					var $checkbox = $('form input[data-metadata-id=' + $(this).attr('data-metadata-id') + ']');
					if ($(this).is(':checked')) {
						$checkbox.prop('checked', true).trigger('change');
					} else {
						$checkbox.prop('checked', false).trigger('change');
					}
				});
				$metadatas.find('input[type=text]').change(function () {
					$('input[data-metadata-id=' + $(this).attr('data-metadata-id') + ']').val(this.value);
				});
				$metadatas.find('textarea').change(function () {
					$('textarea[data-metadata-id=' + $(this).attr('data-metadata-id') + ']').val(this.value);
				});

			} else {
				//disable button
				$metadataButton.click(function () {return false;});
			}

			//category dropdown
			var $categories = $('li.categories', $domobject);
			var $drop = $categories.find('div.dropdown');
			var categoryDropDown = new ImageVaultUi.OrganizeCategoryPopupMenu({ $domobject: $drop });
			this.categoryDropDown = categoryDropDown;
			categoryDropDown.bind("beforeShow", this.initCategoryPopup, this);
			categoryDropDown.bind("beforeHide", this.unbindCategoryEvents, this);
			$categories.find('a').click(function () {
				categoryDropDown.toggle();
				return false;
			});

		},
		//Initializes the category popup
		initCategoryPopup: function () {
			var dropDown = this.categoryDropDown;
			var $domobject = dropDown.get("$domobject");
			//Remove checked state
			$('input[type=checkbox]', $domobject).removeAttr("checked");
			//connect the category select events...
			this.bindCategoryEvents();
		},
		//binds events for the category popup
		bindCategoryEvents: function () {
			var dropDown = this.categoryDropDown;
			var $domobject = dropDown.get("$domobject");
			//All items categories click event.
			$('input[type=checkbox]', $domobject).bind("change.categoryDropDown", function () {
				var $checkbox = $('form input[data-category-id=' + $(this).attr('data-category-id') + ']');
				if ($(this).is(':checked')) {
					// set property on remote categories and trigger change event
					$checkbox.prop('checked', true).trigger('change');
					// set all ancestors
					$(this).parentsUntil('div.dropdown').children('input[type=checkbox]').attr('checked', 'checked');
				} else {
					//Clear all categories below unselected.
					$(this).siblings('ul').find('input[type=checkbox]').removeAttr('checked');
					// uncheck and trigger change event
					$checkbox.prop('checked', false).trigger('change');
				}
			});
		},
		//unbinds events for the category popup
		unbindCategoryEvents: function () {
			var dropDown = this.categoryDropDown;
			var $domobject = dropDown.get("$domobject");
			//undbind the events
			$('input[type=checkbox]', $domobject).unbind("change.categoryDropDown");
		}
	});
	ns.OrganizeAllItemsToolbar = organizeAllItemsToolbar;
})(jQuery, window.ImageVaultUi = window.ImageVaultUi || {});