﻿function XmlDocTransform($xml, $xdt)
{
    if (!$xml -or !(Test-Path -path $xml -PathType Leaf)) {
        throw "File not found. $xml";
    }
    if (!$xdt -or !(Test-Path -path $xdt -PathType Leaf)) {
        throw "File not found. $xdt";
    }
	Write-Host "Loading configuration $xml"
    $xmldoc = New-Object Microsoft.Web.XmlTransform.XmlTransformableDocument;
    $xmldoc.PreserveWhitespace = $true
    $xmldoc.Load($xml);

	Write-Host "Applying transformation $xdt"
    $transf = New-Object Microsoft.Web.XmlTransform.XmlTransformation($xdt);
    if ($transf.Apply($xmldoc) -eq $false)
    {
        throw "Transformation failed."
    }
    $xmldoc.Save($xml);
	Write-Host "Changes saved to $xml"
}


#Updates the web.config with the latest changes
$updateFolder = split-path -parent $MyInvocation.MyCommand.Definition
$xmldll = Join-Path $updateFolder "Microsoft.Web.XmlTransform.dll"
$webrootFolder = Split-Path -Parent $updateFolder
$webConfigFile = Join-Path $webrootFolder "web.config"
$transformFile = Join-Path $updateFolder "web.config.install.xdt"

if(!(Test-Path $xmldll)) {
	throw "Missing dll $xmldll"
}
if(!(Test-Path $webConfigFile)) {
	throw "Missing web.config file $webConfigFile"
}
if(!(Test-Path $transformFile)) {
	throw "Missing update transformation file $transformFile"
}
[Reflection.Assembly]::LoadFile($xmldll)>$null
XmlDocTransform $webConfigFile $transformFile
	